from .second_quantization import linear_terms

# spinful model
hamiltonian_terms = {
    'Delta_real': [
        [(2, 3), (1, 1), 1]
    ],
    'Delta_imag': [
        [(2, 3), (1, 1), 1j]
    ],
    't': [
        [(2, 0), (1, -1), 1],
        [(3, 1), (1, -1), 1],
        [(2, 4), (1, -1), 1], 
        [(3, 5), (1, -1), 1]
    ],
    'tso':[
        [(3, 0), (1, -1), -1],
        [(2, 1), (1, -1), 1],
        [(3, 4), (1, -1), 1],
        [(2, 5), (1, -1), -1], 
    ],
    'muR': [
        [(4, 4), (1, -1), 1],
        [(5, 5), (1, -1), 1]
    ],
    'muM': [
        [(2, 2), (1, -1), 1],
        [(3, 3), (1, -1), 1],
    ],
    'muL': [
        [(0, 0), (1, -1), 1],
        [(1, 1), (1, -1), 1],
    ],
    'EzR': [
        [(5, 5), (1, -1), 1]
    ],
    'EzM': [
        [(3, 3), (1, -1), 1],
        [(2, 2), (1, -1), -1]
    ],
    'EzL': [
        [(1, 1), (1, -1), 1],
    ],
    'UL': [
        [(0, 1), 1]
    ],
    'UR': [
        [(4, 5), 1]
    ],
    'UM': [
        [(2, 3), 1]
    ],
}

ham_terms = linear_terms(hamiltonian_terms, n_labels=6)

base_params = {
    'Delta_real': 1,
    'Delta_imag': 0,
    't': 0.4,
    'tso': 0.4*0.2,
    'muR': 0,
    'muM': 0,
    'muL': 0,
    'EzR': 4,
    'EzM': 0,
    'EzL': 4,
    'UL': 2,
    'UR': 2,
    'UM': 0,
}