import numpy as np
from scipy.linalg import eigh


def diagonalize_and_explore_gauge(ham_terms, ss_params, majorana_ops=None, npoints=199):

    hams = evaluate_hamiltonian(ham_terms, ss_params)
    even_evals, even_evecs = eigh(hams[0])
    odd_evals, odd_evecs = eigh(hams[1])
    gap = odd_evals[0] - np.min([even_evals[1], odd_evals[1]])

    if majorana_ops is not None:
        phis_2 = np.linspace(0, np.pi, npoints)
        search_pols = []
        search_majs = []
        for theta in phis_2:
            ws, zs = majoran_ops(phi=theta/2)
            maj_1 = get_wfs(even_evecs, odd_evecs, ws[:, 32:, :32])
            maj_2 = get_wfs(even_evecs, odd_evecs, zs[:, 32:, :32])
            search_pols.append(polarization_from_wfs(maj_1, maj_2))
            search_majs.append([maj_1, maj_2])

        return gap, search_pols, search_majs

    else:
        return gap